# API notes

The protocol has three main phases:

* Handshaking
* Syncing
* Active

## Setup

`ObjectsInSpace OIS(numChannels)`: Creats an Objects In Space... uh...
object. `numChannels` is the total maximum number of *request* channels.

## Handshaking

`OIS.begin()`: Periodically attempts to handshake. Blocks until
handshaking is complete. Note that this does not call Serial.begin().

## Syncing

User calls library functions to define commands they want to send,
and register callbacks for assorted functions:

* `OIS.registerCMD(CMD)`: Send a CMD synchronisation command. CMD is one
of a predefined list of constants. This means that a given CMD will always
be on the same channel as far as the game is concerned. This *might* be a
problem if the game expects channels to be globally unique.
* `OIS.registerBool(CMD, callback)`: Send a NIB command. The callback
  is a function that will receive the value.
* `OIS.registerInt(CMD, callback)`: Send a NIN command. The callback
  is a function that will receive the value.
* `OIS.registerFloat(CMD, callback)`: Send a NIF command. The callback
  is a function that will receive the value.
* `OIS.start()`: Called when all setup is done. Move to Active phase.

## Active

Library will call appropriate callbacks as data is received.

* `OIS.sendCommand(CMD)`: Ask the game to EXC the given command.
* `OIS.sendDebug(log)`: Send `log` to the game as a DBG command to be logged.
